/*
 * OpenFairDB API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.9.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.ContactName;
import org.openapitools.client.model.CustomLink;
import org.openapitools.client.model.EntryAllOf;
import org.openapitools.client.model.ImageLink;
import org.openapitools.client.model.ImageUrl;
import org.openapitools.client.model.NewEntryWithLicense;
import org.threeten.bp.LocalDate;

/**
 * Entry
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-12-19T15:07:54.107442+01:00[Europe/Rome]")
public class Entry {
  public static final String SERIALIZED_NAME_TITLE = "title";
  @SerializedName(SERIALIZED_NAME_TITLE)
  private String title;

  public static final String SERIALIZED_NAME_DESCRIPTION = "description";
  @SerializedName(SERIALIZED_NAME_DESCRIPTION)
  private String description;

  public static final String SERIALIZED_NAME_LAT = "lat";
  @SerializedName(SERIALIZED_NAME_LAT)
  private Double lat;

  public static final String SERIALIZED_NAME_LNG = "lng";
  @SerializedName(SERIALIZED_NAME_LNG)
  private Double lng;

  public static final String SERIALIZED_NAME_STREET = "street";
  @SerializedName(SERIALIZED_NAME_STREET)
  private String street;

  public static final String SERIALIZED_NAME_ZIP = "zip";
  @SerializedName(SERIALIZED_NAME_ZIP)
  private String zip;

  public static final String SERIALIZED_NAME_CITY = "city";
  @SerializedName(SERIALIZED_NAME_CITY)
  private String city;

  public static final String SERIALIZED_NAME_COUNTRY = "country";
  @SerializedName(SERIALIZED_NAME_COUNTRY)
  private String country;

  public static final String SERIALIZED_NAME_STATE = "state";
  @SerializedName(SERIALIZED_NAME_STATE)
  private String state;

  public static final String SERIALIZED_NAME_CONTACT_NAME = "contact_name";
  @SerializedName(SERIALIZED_NAME_CONTACT_NAME)
  private ContactName contactName = null;

  public static final String SERIALIZED_NAME_EMAIL = "email";
  @SerializedName(SERIALIZED_NAME_EMAIL)
  private String email = null;

  public static final String SERIALIZED_NAME_TELEPHONE = "telephone";
  @SerializedName(SERIALIZED_NAME_TELEPHONE)
  private String telephone = null;

  public static final String SERIALIZED_NAME_HOMEPAGE = "homepage";
  @SerializedName(SERIALIZED_NAME_HOMEPAGE)
  private String homepage;

  public static final String SERIALIZED_NAME_OPENING_HOURS = "opening_hours";
  @SerializedName(SERIALIZED_NAME_OPENING_HOURS)
  private String openingHours;

  public static final String SERIALIZED_NAME_FOUNDED_ON = "founded_on";
  @SerializedName(SERIALIZED_NAME_FOUNDED_ON)
  private LocalDate foundedOn;

  public static final String SERIALIZED_NAME_CATEGORIES = "categories";
  @SerializedName(SERIALIZED_NAME_CATEGORIES)
  private List<String> categories = null;

  public static final String SERIALIZED_NAME_TAGS = "tags";
  @SerializedName(SERIALIZED_NAME_TAGS)
  private List<String> tags = null;

  public static final String SERIALIZED_NAME_IMAGE_URL = "image_url";
  @SerializedName(SERIALIZED_NAME_IMAGE_URL)
  private ImageUrl imageUrl = null;

  public static final String SERIALIZED_NAME_IMAGE_LINK_URL = "image_link_url";
  @SerializedName(SERIALIZED_NAME_IMAGE_LINK_URL)
  private ImageLink imageLinkUrl = null;

  public static final String SERIALIZED_NAME_LINKS = "links";
  @SerializedName(SERIALIZED_NAME_LINKS)
  private List<CustomLink> links = null;

  public static final String SERIALIZED_NAME_LICENSE = "license";
  @SerializedName(SERIALIZED_NAME_LICENSE)
  private String license;

  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_VERSION = "version";
  @SerializedName(SERIALIZED_NAME_VERSION)
  private Integer version;

  public static final String SERIALIZED_NAME_CREATED = "created";
  @SerializedName(SERIALIZED_NAME_CREATED)
  private Integer created;

  public static final String SERIALIZED_NAME_RATINGS = "ratings";
  @SerializedName(SERIALIZED_NAME_RATINGS)
  private List<String> ratings = null;


  public Entry title(String title) {
    
    this.title = title;
    return this;
  }

   /**
   * Get title
   * @return title
  **/
  @ApiModelProperty(required = true, value = "")

  public String getTitle() {
    return title;
  }


  public void setTitle(String title) {
    this.title = title;
  }


  public Entry description(String description) {
    
    this.description = description;
    return this;
  }

   /**
   * Get description
   * @return description
  **/
  @ApiModelProperty(required = true, value = "")

  public String getDescription() {
    return description;
  }


  public void setDescription(String description) {
    this.description = description;
  }


  public Entry lat(Double lat) {
    
    this.lat = lat;
    return this;
  }

   /**
   * Geographic latitude (in degrees)
   * minimum: -90.0
   * maximum: 90.0
   * @return lat
  **/
  @ApiModelProperty(example = "37.2", required = true, value = "Geographic latitude (in degrees)")

  public Double getLat() {
    return lat;
  }


  public void setLat(Double lat) {
    this.lat = lat;
  }


  public Entry lng(Double lng) {
    
    this.lng = lng;
    return this;
  }

   /**
   * Geographic longitude (in degrees)
   * minimum: -180.0
   * maximum: 180.0
   * @return lng
  **/
  @ApiModelProperty(example = "120.7", required = true, value = "Geographic longitude (in degrees)")

  public Double getLng() {
    return lng;
  }


  public void setLng(Double lng) {
    this.lng = lng;
  }


  public Entry street(String street) {
    
    this.street = street;
    return this;
  }

   /**
   * Get street
   * @return street
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getStreet() {
    return street;
  }


  public void setStreet(String street) {
    this.street = street;
  }


  public Entry zip(String zip) {
    
    this.zip = zip;
    return this;
  }

   /**
   * Get zip
   * @return zip
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getZip() {
    return zip;
  }


  public void setZip(String zip) {
    this.zip = zip;
  }


  public Entry city(String city) {
    
    this.city = city;
    return this;
  }

   /**
   * Get city
   * @return city
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getCity() {
    return city;
  }


  public void setCity(String city) {
    this.city = city;
  }


  public Entry country(String country) {
    
    this.country = country;
    return this;
  }

   /**
   * Get country
   * @return country
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getCountry() {
    return country;
  }


  public void setCountry(String country) {
    this.country = country;
  }


  public Entry state(String state) {
    
    this.state = state;
    return this;
  }

   /**
   * Get state
   * @return state
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getState() {
    return state;
  }


  public void setState(String state) {
    this.state = state;
  }


  public Entry contactName(ContactName contactName) {
    
    this.contactName = contactName;
    return this;
  }

   /**
   * Get contactName
   * @return contactName
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public ContactName getContactName() {
    return contactName;
  }


  public void setContactName(ContactName contactName) {
    this.contactName = contactName;
  }


  public Entry email(String email) {
    
    this.email = email;
    return this;
  }

   /**
   * Get email
   * @return email
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getEmail() {
    return email;
  }


  public void setEmail(String email) {
    this.email = email;
  }


  public Entry telephone(String telephone) {
    
    this.telephone = telephone;
    return this;
  }

   /**
   * Get telephone
   * @return telephone
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getTelephone() {
    return telephone;
  }


  public void setTelephone(String telephone) {
    this.telephone = telephone;
  }


  public Entry homepage(String homepage) {
    
    this.homepage = homepage;
    return this;
  }

   /**
   * Get homepage
   * @return homepage
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://www.slowtec.de/", value = "")

  public String getHomepage() {
    return homepage;
  }


  public void setHomepage(String homepage) {
    this.homepage = homepage;
  }


  public Entry openingHours(String openingHours) {
    
    this.openingHours = openingHours;
    return this;
  }

   /**
   * The opening hours in OpenStreetMap format.  Specification: https://wiki.openstreetmap.org/wiki/Key:opening_hours  Reference implementations: https://github.com/opening-hours/  Generator tool: https://projets.pavie.info/yohours/  The service trims leading/trailing whitespaces and stores values as is. Values are currently not validated against the OSM format syntax! 
   * @return openingHours
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "24/7", value = "The opening hours in OpenStreetMap format.  Specification: https://wiki.openstreetmap.org/wiki/Key:opening_hours  Reference implementations: https://github.com/opening-hours/  Generator tool: https://projets.pavie.info/yohours/  The service trims leading/trailing whitespaces and stores values as is. Values are currently not validated against the OSM format syntax! ")

  public String getOpeningHours() {
    return openingHours;
  }


  public void setOpeningHours(String openingHours) {
    this.openingHours = openingHours;
  }


  public Entry foundedOn(LocalDate foundedOn) {
    
    this.foundedOn = foundedOn;
    return this;
  }

   /**
   * The date on which an organization, initiative, or company has been founded or established. 
   * @return foundedOn
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Wed Oct 24 01:00:00 CET 1945", value = "The date on which an organization, initiative, or company has been founded or established. ")

  public LocalDate getFoundedOn() {
    return foundedOn;
  }


  public void setFoundedOn(LocalDate foundedOn) {
    this.foundedOn = foundedOn;
  }


  public Entry categories(List<String> categories) {
    
    this.categories = categories;
    return this;
  }

  public Entry addCategoriesItem(String categoriesItem) {
    if (this.categories == null) {
      this.categories = new ArrayList<String>();
    }
    this.categories.add(categoriesItem);
    return this;
  }

   /**
   * Get categories
   * @return categories
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public List<String> getCategories() {
    return categories;
  }


  public void setCategories(List<String> categories) {
    this.categories = categories;
  }


  public Entry tags(List<String> tags) {
    
    this.tags = tags;
    return this;
  }

  public Entry addTagsItem(String tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<String>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * Get tags
   * @return tags
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "[\"organic\",\"non-profit\"]", value = "")

  public List<String> getTags() {
    return tags;
  }


  public void setTags(List<String> tags) {
    this.tags = tags;
  }


  public Entry imageUrl(ImageUrl imageUrl) {
    
    this.imageUrl = imageUrl;
    return this;
  }

   /**
   * Get imageUrl
   * @return imageUrl
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public ImageUrl getImageUrl() {
    return imageUrl;
  }


  public void setImageUrl(ImageUrl imageUrl) {
    this.imageUrl = imageUrl;
  }


  public Entry imageLinkUrl(ImageLink imageLinkUrl) {
    
    this.imageLinkUrl = imageLinkUrl;
    return this;
  }

   /**
   * Get imageLinkUrl
   * @return imageLinkUrl
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public ImageLink getImageLinkUrl() {
    return imageLinkUrl;
  }


  public void setImageLinkUrl(ImageLink imageLinkUrl) {
    this.imageLinkUrl = imageLinkUrl;
  }


  public Entry links(List<CustomLink> links) {
    
    this.links = links;
    return this;
  }

  public Entry addLinksItem(CustomLink linksItem) {
    if (this.links == null) {
      this.links = new ArrayList<CustomLink>();
    }
    this.links.add(linksItem);
    return this;
  }

   /**
   * An unordered list of custom links.  The ordering of list items may change between different revisions even if this list has not been modified. Don&#39;t make any assumptions about a particular ordering! 
   * @return links
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "An unordered list of custom links.  The ordering of list items may change between different revisions even if this list has not been modified. Don't make any assumptions about a particular ordering! ")

  public List<CustomLink> getLinks() {
    return links;
  }


  public void setLinks(List<CustomLink> links) {
    this.links = links;
  }


  public Entry license(String license) {
    
    this.license = license;
    return this;
  }

   /**
   * Get license
   * @return license
  **/
  @ApiModelProperty(example = "CC0-1.0", required = true, value = "")

  public String getLicense() {
    return license;
  }


  public void setLicense(String license) {
    this.license = license;
  }


  public Entry id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * Identifier of a resource 
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "7cee99c287094a94acbdcf29ffff2e85", value = "Identifier of a resource ")

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public Entry version(Integer version) {
    
    this.version = version;
    return this;
  }

   /**
   * Get version
   * @return version
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Integer getVersion() {
    return version;
  }


  public void setVersion(Integer version) {
    this.version = version;
  }


  public Entry created(Integer created) {
    
    this.created = created;
    return this;
  }

   /**
   * Get created
   * @return created
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Integer getCreated() {
    return created;
  }


  public void setCreated(Integer created) {
    this.created = created;
  }


  public Entry ratings(List<String> ratings) {
    
    this.ratings = ratings;
    return this;
  }

  public Entry addRatingsItem(String ratingsItem) {
    if (this.ratings == null) {
      this.ratings = new ArrayList<String>();
    }
    this.ratings.add(ratingsItem);
    return this;
  }

   /**
   * Get ratings
   * @return ratings
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public List<String> getRatings() {
    return ratings;
  }


  public void setRatings(List<String> ratings) {
    this.ratings = ratings;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Entry entry = (Entry) o;
    return Objects.equals(this.title, entry.title) &&
        Objects.equals(this.description, entry.description) &&
        Objects.equals(this.lat, entry.lat) &&
        Objects.equals(this.lng, entry.lng) &&
        Objects.equals(this.street, entry.street) &&
        Objects.equals(this.zip, entry.zip) &&
        Objects.equals(this.city, entry.city) &&
        Objects.equals(this.country, entry.country) &&
        Objects.equals(this.state, entry.state) &&
        Objects.equals(this.contactName, entry.contactName) &&
        Objects.equals(this.email, entry.email) &&
        Objects.equals(this.telephone, entry.telephone) &&
        Objects.equals(this.homepage, entry.homepage) &&
        Objects.equals(this.openingHours, entry.openingHours) &&
        Objects.equals(this.foundedOn, entry.foundedOn) &&
        Objects.equals(this.categories, entry.categories) &&
        Objects.equals(this.tags, entry.tags) &&
        Objects.equals(this.imageUrl, entry.imageUrl) &&
        Objects.equals(this.imageLinkUrl, entry.imageLinkUrl) &&
        Objects.equals(this.links, entry.links) &&
        Objects.equals(this.license, entry.license) &&
        Objects.equals(this.id, entry.id) &&
        Objects.equals(this.version, entry.version) &&
        Objects.equals(this.created, entry.created) &&
        Objects.equals(this.ratings, entry.ratings);
  }

  @Override
  public int hashCode() {
    return Objects.hash(title, description, lat, lng, street, zip, city, country, state, contactName, email, telephone, homepage, openingHours, foundedOn, categories, tags, imageUrl, imageLinkUrl, links, license, id, version, created, ratings);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Entry {\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    lat: ").append(toIndentedString(lat)).append("\n");
    sb.append("    lng: ").append(toIndentedString(lng)).append("\n");
    sb.append("    street: ").append(toIndentedString(street)).append("\n");
    sb.append("    zip: ").append(toIndentedString(zip)).append("\n");
    sb.append("    city: ").append(toIndentedString(city)).append("\n");
    sb.append("    country: ").append(toIndentedString(country)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    contactName: ").append(toIndentedString(contactName)).append("\n");
    sb.append("    email: ").append(toIndentedString(email)).append("\n");
    sb.append("    telephone: ").append(toIndentedString(telephone)).append("\n");
    sb.append("    homepage: ").append(toIndentedString(homepage)).append("\n");
    sb.append("    openingHours: ").append(toIndentedString(openingHours)).append("\n");
    sb.append("    foundedOn: ").append(toIndentedString(foundedOn)).append("\n");
    sb.append("    categories: ").append(toIndentedString(categories)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    imageUrl: ").append(toIndentedString(imageUrl)).append("\n");
    sb.append("    imageLinkUrl: ").append(toIndentedString(imageLinkUrl)).append("\n");
    sb.append("    links: ").append(toIndentedString(links)).append("\n");
    sb.append("    license: ").append(toIndentedString(license)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    ratings: ").append(toIndentedString(ratings)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

